Index: /trunk/Config.kmk
===================================================================
--- /trunk/Config.kmk	(revision 61503)
+++ /trunk/Config.kmk	(revision 61504)
@@ -221,5 +221,5 @@
 #       publisher so that RTStrVersionCompare have a chance of comparing
 #       prerelease from different publishers correctly.
-VBOX_VERSION_STRING = $(VBOX_VERSION_STRING_RAW)_BETA1$(VBOX_BUILD_PUBLISHER)
+VBOX_VERSION_STRING = $(VBOX_VERSION_STRING_RAW)_BETA2$(VBOX_BUILD_PUBLISHER)
 # Just the BETA[n],ALPHA[n],RC[n] indicators. Set to empty string for release.
 VBOX_VERSION_PRERELEASE =
@@ -231,9 +231,9 @@
 endif
 ifneq ($(VBOX_RELEASE_EXACT_MATCH),)
-# export VBOX_ADDITIONS_SH_MODE     = release
-# export VBOX_DOCUMENTATION_SH_MODE = release
-# export VBOX_EFI_SH_MODE           = release
-# export VBOX_EXTPACKS_SH_MODE      = release
-# VBOX_WITH_AUDIO_STABLE           := 1
+ export VBOX_ADDITIONS_SH_MODE     = release
+ export VBOX_DOCUMENTATION_SH_MODE = release
+ export VBOX_EFI_SH_MODE           = release
+ export VBOX_EXTPACKS_SH_MODE      = release
+ VBOX_WITH_AUDIO_STABLE           := 1
 endif
 
Index: /trunk/debian/changelog
===================================================================
--- /trunk/debian/changelog	(revision 61503)
+++ /trunk/debian/changelog	(revision 61504)
@@ -1,2 +1,8 @@
+virtualbox-ose (5.1.0~beta2) unstable; urgency=low
+
+  * rebuild Debian package.
+
+ -- Oracle Corporation <info@virtualbox.org>  Mon, 06 Jun 2016 18:00:00 +0200
+
 virtualbox-ose (5.1.0~beta1) unstable; urgency=low
 
Index: /trunk/doc/manual/user_ChangeLogImpl.xml
===================================================================
--- /trunk/doc/manual/user_ChangeLogImpl.xml	(revision 61503)
+++ /trunk/doc/manual/user_ChangeLogImpl.xml	(revision 61504)
@@ -4,5 +4,5 @@
                            So, we use chapter and xpointer="xpointer(/chapter/)" with xi:include. -->
   <sect1>
-    <title>Version 5.1.0 Beta 1 (2016-06-03)</title>
+    <title>Version 5.1.0 Beta 2 (2016-06-06)</title>
 
     <para>This is a major update. The following major new features
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.asm	(revision 61504)
@@ -7294,5 +7294,5 @@
 section _DATA progbits vstart=0x4600 align=1 ; size=0x372a class=DATA group=DGROUP
 _msg_vga_init:                               ; 0xc4600 LB 0x34
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
 _vga_modes:                                  ; 0xc4634 LB 0x80
     db  000h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h, 001h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h
@@ -8189,5 +8189,5 @@
     db  'Oracle VM VirtualBox VBE Adapter', 000h
 _vbebios_product_revision:                   ; 0xc7cad LB 0x29
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1', 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2', 000h
 _vbebios_info_string:                        ; 0xc7cd6 LB 0x2b
     db  'VirtualBox VBE Display Adapter enabled', 00dh, 00ah, 00dh, 00ah, 000h
@@ -8245,3 +8245,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 0a5h
+    db  000h, 000h, 000h, 000h, 000h, 0a3h
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative286.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-6434407a42207a0962b52e765524fb61 *VBoxVgaBios286.rom
+9727914de718f67e5ebeb8d9e14ffc7f *VBoxVgaBios286.rom
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.asm	(revision 61504)
@@ -6770,5 +6770,5 @@
 section _DATA progbits vstart=0x4600 align=1 ; size=0x372a class=DATA group=DGROUP
 _msg_vga_init:                               ; 0xc4600 LB 0x34
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
 _vga_modes:                                  ; 0xc4634 LB 0x80
     db  000h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h, 001h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h
@@ -7665,5 +7665,5 @@
     db  'Oracle VM VirtualBox VBE Adapter', 000h
 _vbebios_product_revision:                   ; 0xc7cad LB 0x29
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1', 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2', 000h
 _vbebios_info_string:                        ; 0xc7cd6 LB 0x2b
     db  'VirtualBox VBE Display Adapter enabled', 00dh, 00ah, 00dh, 00ah, 000h
@@ -7721,3 +7721,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 09ah
+    db  000h, 000h, 000h, 000h, 000h, 098h
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative386.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-4a278b851b2355f9231b7908e6d8cc24 *VBoxVgaBios386.rom
+1c8f189df8789c682edee12869f61a6f *VBoxVgaBios386.rom
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.asm	(revision 61504)
@@ -7435,5 +7435,5 @@
 section _DATA progbits vstart=0x4600 align=1 ; size=0x372a class=DATA group=DGROUP
 _msg_vga_init:                               ; 0xc4600 LB 0x34
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1 VGA BIOS', 00dh, 00ah, 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2 VGA BIOS', 00dh, 00ah, 000h
 _vga_modes:                                  ; 0xc4634 LB 0x80
     db  000h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h, 001h, 000h, 000h, 004h, 000h, 0b8h, 0ffh, 002h
@@ -8330,5 +8330,5 @@
     db  'Oracle VM VirtualBox VBE Adapter', 000h
 _vbebios_product_revision:                   ; 0xc7cad LB 0x29
-    db  'Oracle VM VirtualBox Version 5.1.0_BETA1', 000h
+    db  'Oracle VM VirtualBox Version 5.1.0_BETA2', 000h
 _vbebios_info_string:                        ; 0xc7cd6 LB 0x2b
     db  'VirtualBox VBE Display Adapter enabled', 00dh, 00ah, 00dh, 00ah, 000h
@@ -8386,3 +8386,3 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-    db  000h, 000h, 000h, 000h, 000h, 02ch
+    db  000h, 000h, 000h, 000h, 000h, 02ah
Index: /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum
===================================================================
--- /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/Graphics/BIOS/VBoxVgaBiosAlternative8086.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-c7cb0532637bd94025a3c94ba7dec94b *VBoxVgaBios8086.rom
+2c2939e2a335c9e0383a90ab0c8fafbf *VBoxVgaBios8086.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 61504)
@@ -1116,5 +1116,5 @@
 section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.1.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.1.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0da6 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -17815,3 +17815,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0b6h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0b5h
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-e60792d24836fa6142a8c88308e5d471 *VBoxPcBios286.rom
+be6304942687d1f31a0eb1f9c3de9a88 *VBoxPcBios286.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.asm	(revision 61504)
@@ -1079,5 +1079,5 @@
 section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.1.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.1.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0da6 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -17203,3 +17203,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 023h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 022h
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative386.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-890e247d97432e9e07c2991ec35dbb39 *VBoxPcBios386.rom
+881ba8458daafcbffd5fd8f0e667d905 *VBoxPcBios386.rom
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.asm	(revision 61504)
@@ -1116,5 +1116,5 @@
 section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
 _bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.1.0_BETA1', 000h, 000h
+    db  'VirtualBox 5.1.0_BETA2', 000h, 000h
 _bios_prefix_string:                         ; 0xf0da6 LB 0x8
     db  'BIOS: ', 000h, 000h
@@ -18274,3 +18274,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 072h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fbh, 071h
Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 61503)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative8086.md5sum	(revision 61504)
@@ -1,1 +1,1 @@
-7704911a55513dd7fbb30bfba50e9490 *VBoxPcBios8086.rom
+0ee9bcbf48120aac81369fb860894d3f *VBoxPcBios8086.rom